/* -*- mode: linux-c -*-
 *
 *      Copyright (C) 2005-2006 Cyrill Gorcunov <gclion@mail.ru>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *      May God bless you!
 *
 */

#ifndef EPRINTF_H_
#define EPRINTF_H_

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#define EPRINTF(message)		xo_eprintf(__FILE__, __LINE__, message)
#define EPRINTF_INIT			extern char* eprintf_progname
#define EPRINTF_SETNAME(prog_name)	eprintf_progname = prog_name
#define DPRINTF(message)		xo_dprintf(__FILE__, __LINE__, message)

#define DPROC_IN(proc)			"--> " proc
#define DPROC_OUT(proc)			"<-- " proc

#define msg(fmt, arg ...)						\
do {									\
	printf(PACKAGE_NAME "-" PACKAGE_VERSION ": %s:%i " fmt "\n",	\
	       __FILE__, __LINE__, ## arg);	\
} while(0)

void xo_eprintf(char* file, int line, char *fmt, ...);
void xo_dprintf(char* file, int line, char *fmt, ...);


#endif/*EPRINTF_H_*/
